#ifndef __V24_COMMANDS_H__
#define __V24_COMMANDS_H__

//
// C++ Interface: v24_commands
//
// Description: 
//
//
// Author: Michel Tokic,,, <michel@tokic>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//


// V24 Kommandos
#define V24_COMMAND_SYNC_COMMAND	0x00  // Synchronisierungsbefehl
#define V24_COMMAND_SYNC_OK_COMMAND	0xff  // Sychronisierungsbest�tigung
#define V24_COMMAND_LED_ON 		0x01  // LED Test "an"
#define V24_COMMAND_LED_OFF 		0x02  // LED Test "aus"

#define V24_COMMAND_GET_GAMMA		0x03  // Anforderung zum übertragen des gamma
#define V24_COMMAND_SET_GAMMA		0x04  // Gamma im µC setzen

#define V24_COMMAND_SET_GRIDSIZE	0x05  // setzt ScalX und ScalY
#define V24_COMMAND_GET_GRIDSIZE	0x06  // setzt ScalX und ScalY

#define V24_COMMAND_START_WALKING	0x07  // laufe auf aktueller policy
#define V24_COMMAND_STOP_WALKING	0x08  // stoppe das laufen auf der aktuellens policy

#define V24_COMMAND_SET_STATE		0x09  // setzt einen Zustand
#define V24_COMMAND_GET_STATE		0x0A  // liefert einen bestimmten Zustand

#define V24_COMMAND_WRITE_RAM_BYTES	0x0B  // (Ramtest) schreibt 16 bytes in den RAM
#define V24_COMMAND_READ_RAM_BYTES	0x0C  // (Ramtest) ließt 16 Bytes aus dem RAM

#define V24_COMMAND_EXPLORE_FEEDBACK	0x0D  // Erkundet Feedback

#define V24_COMMAND_COMMAND_OK		0x0E  // Kommando wurde korrekt empfangen und ausgewertet
#define V24_COMMAND_COMMAND_ERROR	0x0F  // Kommando wurde nicht korrekt empfangen => Fehlercode ist im Anhang

#define V24_COMMAND_GET_CURRENTPOSITION_AND_MODE	0x10  // Anfrage nach aktueller Position und aktuellem Modus
#define V24_COMMAND_SET_CURRENTPOSITION_AND_MODE	0x11  // Setzen von aktueller Position und aktuellem Modus (in der GUI)

#define V24_COMMAND_SET_ALL_STATES_AND_GAMMA	0x12  // Setzt alle Zustände
#define V24_COMMAND_GET_ALL_STATES_AND_GAMMA	0x13  // Liefert alle Zustände

#define V24_COMMAND_GET_RAMSIZE				0x14  // Anfrage für Ramgröße
#define V24_COMMAND_SET_RAMSIZE				0x15  // Liefert die Ramgröße

#define V24_COMMAND_START_LEARNING			0x16  // Roboter soll anfangen zu lernen

#define V24_COMMAND_GET_DISTANCE			0x17  // Anfrage nach gelaufener Distanz
#define V24_COMMAND_SET_DISTANCE			0x18  // returns the distance moved forward
#define V24_COMMAND_RESET_DISTANCE_COUNTER		0x19  // resets the distance counter

#define V24_COMMAND_SET_EXPLORATION_CONFIG		0x1A  // set the exploration parameter
#define V24_COMMAND_GET_EXPLORATION_CONFIG		0x1C  // get the explorations parameter

#define V24_COMMAND_WALK_AND_RETURN 			0x1B  // execute aktion and return reward
#define V24_COMMAND_GET_DEBUG				0x1D // returns user defined debug information


/******************************
 * Modi für Hauptprogramm     *
 ******************************/
#define MAIN_MODE_STOP			0	// nix tun
#define MAIN_MODE_WALK_POLICY		1	// Aktuelle Policy ablaufen
#define MAIN_MODE_EXPLORE_FEEDBACK	2	// Feedback erkunden
#define MAIN_MODE_READ_V24		3	// V24-Kommando abarbeiten
#define MAIN_MODE_LEARN			4	// lernen lassen


/*******************************
 * Explorations-Modus
 *******************************/
#define V24_EXP_MODE_EGREEDY		0x00
#define V24_EXP_MODE_VALUE_BASED	0x01



#endif

