#include "gui.h"

/**
*
*/
void Simulation::start_simulation_clicked() {

	// Buttons en- und disablen (lg=lokale Ansicht; sd=externe Ansicht)
	this->lg->startSimulationButton->setEnabled(false);
	this->lg->stopSimulationButton->setEnabled(true);
	this->lg->resumeSimulationButton->setEnabled(false);	
	this->sd->startSimulationButton->setEnabled(false);
	this->sd->stopSimulationButton->setEnabled(true);
	this->sd->resumeSimulationButton->setEnabled(false);	
	this->debugOutput("start simulation");

	// Roboter in Grundposition bringen
	this->simuPos.setX(0);
	this->simuPos.setY(0);

	// In GUI integrierte Simulation
	this->lg->canvasView->setDimension (	this->lg->numRows->value(),
					    	this->lg->numCols->value(),
						this->simuPos.y()+1,
						this->simuPos.x()+1
	);

	// In externen Dialog integrierte Simulation
	this->sd->canvasView->setDimension (	this->lg->numRows->value(),
					    	this->lg->numCols->value(),
						this->simuPos.y()+1,
						this->simuPos.x()+1
	);

	// externen Dialog sichtbar machen
	this->sd->show();

	// Timer starten um automatisch in den nächsten Zustand wechseln zu können
	this->st->start(1000, 0);	
}

/**
*
*/
void Simulation::resume_simulation_clicked() {
	// Buttons en- und disablen
	this->lg->startSimulationButton->setEnabled(false);
	this->lg->stopSimulationButton->setEnabled(true);
	this->lg->resumeSimulationButton->setEnabled(false);	
	this->sd->startSimulationButton->setEnabled(false);
	this->sd->stopSimulationButton->setEnabled(true);
	this->sd->resumeSimulationButton->setEnabled(false);
	// Timer starten um automatisch in den nächsten Zustand zu wechseln
	this->st->start(1000, 0);	
}

/**
*
*/
void Simulation::stop_simulation_clicked() {
	this->debugOutput("stop simulation");
	this->st->stop();
	this->lg->startSimulationButton->setEnabled(true);
	this->lg->stopSimulationButton->setEnabled(false);
	this->lg->resumeSimulationButton->setEnabled(true);	
	this->sd->startSimulationButton->setEnabled(true);
	this->sd->stopSimulationButton->setEnabled(false);
	this->sd->resumeSimulationButton->setEnabled(true);
}

/**
*
*/
void Simulation::simulationWalk() {

	//Thread während der Operation anhalten
	this->st->stop();

	// Aktuelle Position steht in this->simuPos
	// Neue Position steht in this->simuPosNeu
	if (this->action[simuPos.y()][simuPos.x()] == UP) {
		this->simuPosNew.setX( this->simuPos.x());
		this->simuPosNew.setY( this->simuPos.y() -1 );
	}
	else if (this->action[simuPos.y()][simuPos.x()] == DOWN) {
		this->simuPosNew.setX( this->simuPos.x());
		this->simuPosNew.setY( this->simuPos.y() +1 );
	}
	else if (this->action[simuPos.y()][simuPos.x()] == LEFT) {
		this->simuPosNew.setX( this->simuPos.x() -1);
		this->simuPosNew.setY( this->simuPos.y());
	}
	else if (this->action[simuPos.y()][simuPos.x()] == RIGHT) {
		this->simuPosNew.setX( this->simuPos.x() +1);
		this->simuPosNew.setY( this->simuPos.y());
	}

	this->simuPos = this->simuPosNew;

	// In GUI integrierte Simulation
	this->lg->canvasView->moveRobot (this->simuPos.y()+1, this->simuPos.x()+1);	
	// In externen Dialog integrierte Simulation
	this->sd->canvasView->moveRobot (this->simuPos.y()+1, this->simuPos.x()+1);
	this->sd->show();

	this->debugOutput ("Position: Row=" + QString::number(this->simuPos.y() +1) + 
			   ", Column=" + QString::number(this->simuPos.x() +1) );

	//Thread wieder weiterlaufen lassen
	this->st->start(1000, 0);
}
