#include "qWorld.h"
#include <stdio.h>
QWorld::QWorld(){
	printf("Konstruktor\n");
}

QWorld::~QWorld(){
	printf("Destruktor\n");
	for (int j = 0; j < size.x ; j++){
		delete [] memory[j] ;
	}
	delete [] memory; 
}

QWorld* QWorld::getInstance(){
	if( instanz == NULL ){
		instanz = new QWorld();
	}
	return instanz;

}

void QWorld::destroyInstance(){
	if(instanz != NULL){
		delete instanz;
	}
}

void QWorld::setSize(const int XMax, const int YMax){
	size.x = XMax;
	size.y = YMax;
	memory = new cell*[XMax];
	for (int i = 0; i < XMax ; i++){
		memory[i] = new cell[YMax]; 
	}
}

void QWorld::setActualState(int startX, int startY){
	actState.x = startX;
	actState.y = startY;
}

void QWorld::setFeedback(int X, int Y, int direction, double value){
	memory[X][Y].feedbacks[direction] = value;
}
double QWorld::getFeedback(int X, int Y, int direction){
	return memory[X][Y].feedbacks[direction];
}

void QWorld::setActState(int X, int Y){
	actState.x = X;
	actState.y = Y;
}

QState QWorld::getActState(int X, int Y){
	return actState;
}

void QWorld::setParameters(double gamma, double alpha, double epsilon){
	this->gamma = gamma;
	this->alpha = alpha;
	this->epsilon = epsilon;
}

double QWorld::getAlpha(){
	return this->alpha;
}

double QWorld::getGamma(){
	return this->gamma;
}

double QWorld::getEpsilon(){
	return this->epsilon;
}

int QWorld::getX(){
	return (int)this->size.x;
}

int QWorld::getY(){
	return (int)this->size.y;
}

QWorld* QWorld::instanz = 0;
