#ifndef QWORLD_H
#define QWORLD_H


struct QState {
    int x;
    int y;
};

class QWorld
{
	private:	
		struct cell {
			double feedbacks[4];
			double qValues[4];
		} ** memory;
		struct QState actState;
		struct QState size;
		static QWorld* instanz;
		QWorld();
		QWorld(const QWorld&);
		~QWorld();
		double gamma, alpha, epsilon;
		
	public:
		static QWorld* getInstance();
		static void destroyInstance();
		void setSize(const int XMax, const int YMax);
		void setActualState(int startX, int startY);
		void setFeedback(int X, int Y, int direction, double value);
		double getFeedback(int X, int Y, int direction);
		void setQValue(int X, int Y, int direction, double value) {
			memory[X][Y].qValues[direction] = value;
		}
		double getQValue(const int X, const int Y, const int direction) const {
			return memory[X][Y].qValues[direction];
		}
		void setActState(int X, int Y);
		QState getActState(int X, int Y);
		void setParameters(double gamma, double alpha, double epsilon);
		double getAlpha();
		double getGamma();
		double getEpsilon();
		int getX();
		int getY();
};


#endif
