#include <qcanvas.h>
#include <qmessagebox.h>
#include <qpoint.h>
#include "gui_debug.h"
#include <iostream>



#define FRAMEPIX "pix/simu_rahmen.gif"
#define BASEPIX "pix/simu_sockel.gif"
#define HOLDERPIX "pix/simu_halter.gif"

using namespace std;

/**
* Description of the Class MyCanvasView
*/
class MyCanvasView : public QCanvasView
{

  public:
  	MyCanvasView( QCanvas *c, QWidget *parent=0, const char *name=0, WFlags f=0 ) : QCanvasView( c, parent, name, f ) {
		canvas = c;
		initCanvas();		
	}

  	MyCanvasView( QWidget *parent=0, const char *name=0) : QCanvasView( parent, name, 0 ) {
		canvas = new QCanvas(canvas_width, canvas_height);
		initCanvas();		
	}

	void moveRobot(int _row, int _col);
	void setDimension (int _rows, int _cols, int _initRow, int _initCol);

  private:
	// Eigenschaften
	QCanvas *canvas;
	QCanvasSprite *frame, *base, *holder;
	QCanvasPixmapArray *frame_pix, *base_pix, *holder_pix;
	QCanvasRectangle *bottom;
	QCanvasText *distanceText, *posText;
	QPoint oldPos;

	static const int canvas_width = 460;
	static const int canvas_height = 400;

	static const int stand_total_width = 330;
	static const int stand_total_height = 118;
	static const int stand_beam_width = 15;
	static const int stand_beam_height = 15;
	 
	static const int base_total_width = 170;
	static const int base_total_height = 200;	
	static const int base_beam_width = 36;
	static const int base_beam_height = 20;

	static const int holder_total_width = 46;
	static const int holder_total_height = 29;	

	static const int base_inner_height = base_total_height - base_beam_height - stand_beam_height;
	static const int stand_inner_height = stand_total_height - (2*stand_beam_height);
	static const int stand_inner_width = stand_total_width - (2*stand_beam_width) - base_total_width;

	static const int bottom_start_y = stand_total_height + 
			(base_total_height - stand_beam_height - base_beam_height) +1;

	static const int bottom_width = stand_total_width + (stand_inner_width - base_total_width);

	int iRows, iCols;
	int distance;

	// Funktionen
	void initCanvas();
	void paintBottom();
};


