/***************************************************************************
 *   Copyright (C) 2009 by Arne Usadel   *
 *   Arne.Usadel@hs-weingarten.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef BusController_h
#define BusController_h

#include <qobject.h>
#include <qaction.h>
#include <qtimer.h>
#include <deque>

#include "BioloidMainWindow.h"
#include "AX12Dialog.h"

#include "BusController.h"
#include "serialport_d2xx.h"
#include "serialport_ftdi.h"
#include "connection.h"
#include "packet.h"
#include "ax12.h"

/**
	@author Arne Usadel <Arne.Usadel@hs-weingarten.de>
*/
class BusController : public QObject
{
	Q_OBJECT
private:
	BusController();
	BusController(BioloidMainWindow*);
	~BusController();
	static BusController* singletonInst;

	BioloidMainWindow* mainWin;
	int activeAX;
	SerialPort *pSerialPort;
	Connection *pConn;

	std::deque<int> actuatorList;
	QTimer *pUpdateTimer;

public:
	static BusController* getSingletonInst();
	static BusController* getSingletonInst(BioloidMainWindow *mw);
	void shutdown();

public slots:
	void scanBus();
	void activateAX();
	void positionChanged(int);
	void updateTable();
};

#endif
