#ifndef __SERVO_H__
#define __SERVO_H__

#include "global.h"


#define TIMER0  0x00
#define TIMER1A 0x01
#define TIMER1B 0x02
#define TIMER0_PRESCALER 1024L
#define TIMER1_PRESCALER 8L

#define T_PWM				0.020  	/* t für eine PWM Periode */
#define T_PWM_MIN			0.001   /* t für die minimale 1-laenge */
#define T_PWM_MAX			0.002   /* t für die maximale 1-laenge */


#define T0_MAX_UP			(unsigned char)((T_PWM_MAX)/((double)1/(F_CPU/TIMER0_PRESCALER)))
#define T0_MAX_DOWN			(unsigned char)((T_PWM_MIN)/((double)1/(F_CPU/TIMER0_PRESCALER)))
#define T0_SERVO_MIDDLE			(unsigned char)(T0_MAX_UP - (((double)(T0_MAX_UP - T0_MAX_DOWN))/2))
#define T0_T_PERIODE			(unsigned char)((T_PWM)/((double)1/(F_CPU/TIMER0_PRESCALER)))

#define T1_MAX_UP			(unsigned int)((T_PWM_MAX)/((double)1/(F_CPU/TIMER1_PRESCALER)))
#define T1_MAX_DOWN			(unsigned int)((T_PWM_MIN)/((double)1/(F_CPU/TIMER1_PRESCALER)))
#define T1_SERVO_MIDDLE			(unsigned int)(T1_MAX_UP - (((double)(T1_MAX_UP - T1_MAX_DOWN))/2))
#define T1_T_PERIODE			(unsigned int)((T_PWM)/((double)1/(F_CPU/TIMER1_PRESCALER)))

class Servo {

	public: 
		void setPosition(char _pos, char _maxPos);
		void setTimer(char _timer);

	private:
		void initTimer();
		unsigned char timer, startValue;
		unsigned int maxUp, maxDown, servoMiddle;
		
};


#endif
