#ifndef __STATESPACE_H__
#define __STATESPACE_H__

#include "Ram.h"
#include "Environment.h"

class StateSpace {

	public:

		StateSpace(Environment* newEnv);
		~StateSpace();

		void getState (ENV_POS* pos, STATE *_state);
		void setState (ENV_POS* pos, STATE *_state);

		void setValue (ENV_POS* pos, float _value);
		void setBestAction (ENV_POS* pos, unsigned char _action);
		void setFeedback (ENV_POS* pos, unsigned char _action, char _fb);

		double getValue (ENV_POS* pos);
		unsigned char getBestAction (ENV_POS* pos);
		char getFeedback (ENV_POS* pos, unsigned char _action);

		void ramtestSaveBytes(unsigned int _addr, unsigned char *data, unsigned char _length);
		void ramtestReadBytes(unsigned int _addr, unsigned char *data, unsigned char _length);
		unsigned int getMemorySize();

		bool useInternalRAM;

	private:
		STATE tmpState;

		Environment* env;

		// for internal RAM
		unsigned char* internStateSpace; //[STATESIZE*MAX_STATES];

		// for external RAM
		Ram* ram1;
};


#endif

