#ifndef __LERNEN_H__
#define __LERNEN_H__

//#include "Environment.h"
#include "StateSpace.h"

// functions and constants for PRNG
#define PMRAND_MIN 1         		// Min. output
#define PMRAND_MAX 2147483647		// Max. output
#define a 48271
#define m 2147483647
#define q (m / a)
#define r (m % a)

class ValueIteration {

	public:
		ValueIteration (ENV_POS* d);
		~ValueIteration();

		void doNextAction();
		void exploreAllFeedbacks(bool wait5Seconds);
		signed long int getDistanceCovered();
		void resetDistanceCounter();
		unsigned long int getIterationCount();
		char moveAndSaveFeedback (unsigned char _action, bool _activateRandomMoving, ENV_POS* successorState);
		void valueIterateAllStates();

		float gamma;
		float expParameter;
		unsigned char expMode;
		float currentExpProbability;

		/** Environment Object */
		Environment* env;

		/** The StateSpace Object */
		StateSpace* states;

	private:
		unsigned char getGreedyAction(ENV_POS* pos);
		bool doExploration(void);
		float evaluateAction (ENV_POS* pos, unsigned char _action);	
		unsigned short get_seed();
		unsigned char getRandomAction();
		void gotoRandomState();
		//void init();

		unsigned char random_byte;
		unsigned long int iteration;
		signed long int distanceCovered;

		double oldValue;
		double newValue;
};

#endif
