#include "I2c.h"



/***********************
   init  TWI
************************/
void I2c::init(void) {

  TWSR = 0x00;                            // prescale = 1
  TWBR = (unsigned char)(((double)((double)F_CPU / (double)TWI_CLK) - 16L) / 2L);  // 100kHz

}


//**********************************************
//   I2C - start condition
//**********************************************
void I2c::sendStart (void)
{

  TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);	// start condition
  while(!(TWCR & (1<<TWINT)));                   	// wait for acknowledge

}


//**********************************************
//   I2C - Stop condition 
//**********************************************
void I2c::sendStop (void)
{

  TWCR = (1 << TWINT) | (1 << TWSTO) | (1 << TWEN);	// stop condition =0;

}


//**********************************************
//   I2C - address and read
//**********************************************
void I2c::writeByte (unsigned char _byte)
{

  //TWDR = 0x90;                     			// Byte
  TWDR = _byte;                     			// Byte
  TWCR = (1 << TWINT) | (1 << TWEN);           		// send
  while(!(TWCR & (1<<TWINT)));                   	// wait until ready

}

//**********************************************
//   I2C - receive one byte (with acknowledge)
//**********************************************
unsigned char I2c::readByte (void)
{

  TWCR = (1 << TWINT) | (1 << TWEN) | (1 << TWEA);    	// 
  while(!(TWCR & (1<<TWINT)));                		// wait till ready
  return TWDR;						// data is in TWDR

}

// **********************************************
//   I2C - receive one byte (without acknowledge)
// **********************************************
unsigned char I2c::readByteWithoutAck (void)
{

  TWCR = (1 << TWINT) | (1 << TWEN);    		// 
  while(!(TWCR & (1<<TWINT)));                		// wait till ready
  return TWDR;						// data is in TWDR

}
