#ifndef __RAM_H__
#define __RAM_H__

#include "I2c.h"

#define RAM_WREN	0x06  /* Write Enable */
#define RAM_WRDI	0x04  /* Write Disable */
#define RAM_RDSR	0x05  /* Read Status register */
#define RAM_WRSR 	0x01  /* Write to status register */
#define RAM_READ	0x03  /* Read Memory Data */
#define RAM_WRITE	0x02  /* Write Memory Data */


class Ram {

	public:
		void init();
		void writeBytes(uint16_t _addr, unsigned char *_data, unsigned char _length);
		void readBytes(uint16_t _addr, unsigned char *_data, unsigned char _length);

		void setRamStatusRegister (unsigned char _sr);
		unsigned char getRamStatusRegister();

	private:

		void enableRAMChip();
		void disableRAMChip();

		//Spi spi;
		I2c i2c;
		
};


#endif
