#ifndef __STATESPACE_H__
#define __STATESPACE_H__

#include "Ram.h"

class StateSpace {

	public:
		void init();

		void getState (unsigned char _row, unsigned char _column, STATE *_state);
		void setState (unsigned char _row, unsigned char _column, STATE *_state);

		void setValue (unsigned char _row, unsigned char _column, float _value);
		void setBestAction (unsigned char _row, unsigned char _column, unsigned char _action);
		void setFeedback (unsigned char _row, unsigned char _column, unsigned char _action, char _fb);

		double getValue (unsigned char _row, unsigned char _column);
		unsigned char getBestAction (unsigned char _row, unsigned char _column);
		char getFeedback (unsigned char _row, unsigned char _column, unsigned char _action);

		void ramtestSaveBytes(unsigned int _addr, unsigned char *data, unsigned char _length);
		void ramtestReadBytes(unsigned int _addr, unsigned char *data, unsigned char _length);
		unsigned int getMemorySize();

		unsigned char scalX, scalY;
		bool useInternalRAM;

	private:
		STATE tmpState;

		// for internal RAM
		unsigned char internStateSpace[STATESIZE*MAX_STATES];

		// for external RAM
		Ram ram1;
};


#endif

