#ifndef __V24_H__
#define __V24_H__

#include "v24_commands.h"
#include "ValueIteration.h"
//#include "global.h"


/*************************
 * baud-rate definitions *
 *************************/
//#define MYUBRR 	FOSC/16/BAUD-1	
//#define MYUBRR 	5	/* 115.200 bps at 11,0592 MHz */
#define MYUBRR 		35	/* 19.200 bps at 11,0592 MHz) */
//#define MYUBRR 	25	/* 4.800 bps at 1 MHz */
//#define MYUBRR 	143	/* 4.800 bps at 11,0592 MHz */
//#define MYUBRR 	11	/* 57.600 bps at 11,05920 MHz */
//#define MYUBRR 	71	/* 9.600 bps at 11,05920 MHz */
//#define MYUBRR 	287	/* 2.400 bps at 11,05920 MHz */


/********************************************************
 * uniform command structure
 *****************************************************/
typedef struct V24Command {
	unsigned char command;
	unsigned char dataLength;
	unsigned char data[18];
} V24COMMAND;

/**
 * Controll Class for Serial Interface
 * @author Michel
 */
class V24Control {

  public:
		void init();
		void processCommand();
		bool newDataReceived();
		bool receiveCommand (V24COMMAND *c);

		void transmit(unsigned char data);
		bool receive(unsigned char*);
		
		//void disableInterrupt();
		//void enableInterrupt();
		
		ValueIteration vi;

  private:
		bool transmitCommand (V24COMMAND *c);

		bool processGetDebug();
		bool processGetGamma();
		bool processGetExplorationConfig();
		void processSetGamma(V24COMMAND *cmd);
		bool processGetGridsize();
		bool processSetGridsize(V24COMMAND *cmd);
		bool processGetState(V24COMMAND *cmd);
		bool processSetState(V24COMMAND *cmd);
		bool processSetMotorPosition(V24Command);
// 		bool processGetIterations();


		void flushReceiveBuffer();
		bool transmitReceiveCommandProcessed(unsigned char _code, unsigned char _error);

		//unsigned char loopCount;
		STATE tmpState;
		bool rxtx;
		bool newDataAvailable;
};


#endif
