#ifndef __LERNEN_H__
#define __LERNEN_H__

#include "Controller.h"
#include "FeedbackSensor.h"


// functions and constants for PRNG
#define PMRAND_MIN 1         		// Min. output
#define PMRAND_MAX 2147483647		// Max. output
#define a 48271
#define m 2147483647
#define q (m / a)
#define r (m % a)

class ValueIteration {

	public:
		void init();
		void exploreAllFeedbacks(bool wait5Seconds);
		char moveAndSaveFeedback (unsigned char _action, bool _activateRandomMoving);
		void valueIterateAllStates();
		unsigned long int getIterationCount();
		signed long int getDistanceCovered();
		void resetDistanceCounter();
		unsigned char getGreedyAction(unsigned char _row, unsigned char _column);

		/** Contoller Object */
		Controller ctr;

		float gamma;
		float expParameter;
		unsigned char expMode;
		float currentExpProbability;

		double oldValue;
		double newValue;

	private:

		bool isValidAction(unsigned char _row, unsigned char _column, unsigned char _aktion);
		float evaluateAction (unsigned char _row, unsigned char _column, unsigned char _action);	
		unsigned short get_seed();
		unsigned char getRandomAction();
		bool doExploration(void);

		unsigned char random_byte;
		unsigned long int iteration;
		signed long int distanceCovered;
		void gotoRandomState();

		/** Feedback Sensor */
		FeedbackSensor fb;
};

#endif
