#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <avr/io.h>
#include <avr/interrupt.h>
#include <math.h>

#include <stdlib.h>




/********************
 * global constants *
 ********************/
/** 
 * CPU clock
 */
#define F_CPU 	11059200UL
#include <avr/delay.h>

/** 
 * Maximum size of statespace (amount of states) 
 */
#define MAX_STATES 200

/** 
 * time that a servo needs for the movement from LEFT to RIGHT
 */
//#define DELAY_TIME 1200L
#define DELAY_TIME 800L

/**
 * Action Set
 */
#define UP	0x00
#define DOWN 	0x01
#define LEFT 	0x02
#define RIGHT	0x03
#define NONE    0x04
#define NUM_ACTIONS 0x04

/**
 * state structure
 */
typedef struct State {
	float value;
	//unsigned char best_action;
	char feedback_up;
	char feedback_down;
	char feedback_left;
	char feedback_right;
} STATE;
/**
 * determine the amount of memory-bytes which a state requires
 */
#define STATESIZE sizeof(State)


/**
	Exploration Modes
*/
#define EXPLORATION_EGREEDY 0
#define EXPLORATION_VALUE_BASED 1

#endif

