#define F_CPU 	11059200UL
#include <avr/io.h>
#include <avr/delay.h>
#include <avr/interrupt.h>

#include "Controller.h"

#define TEST_MODE 1


void msDelay (int n) {

	double maxDelay = (262.14 / (F_CPU / 1000000));

	for (int i=0; i< (n/maxDelay); i++) {
		_delay_ms (maxDelay);
	}
}


void powerOnLED(unsigned char _ledID, bool _status) {

	if (_status == true) {
		PORTA &= ~(1<<_ledID);
	} else {
		PORTA |= (1<<_ledID);
	}
}

void debugTestProgramm () { 

        Controller c;
	c.init();

	//c.blinkLED((1<<LED_WALK)|(1<<LED_LEARN)|(1<<LED_EXPLORATION), 100, 500);

	// Datenflussregister auf PortA
	DDRA = 0x0F;
	PORTA |= (1<<PA4) | (1<<PA5) | (1<<PA6) | (1<<PA7);


	while (1) {
/*
		powerOnLED(0x00, 0);
		powerOnLED(0x01, 1);
		powerOnLED(0x02, 1);
		powerOnLED(0x03, 0);
		msDelay(500);
		powerOnLED(0x00, 1);
		powerOnLED(0x01, 0);
		powerOnLED(0x02, 0);
		powerOnLED(0x03, 1);
		msDelay(500);
*/

		c.powerOnLED(0x00, 0);
		c.powerOnLED(0x01, 1);
		c.powerOnLED(0x02, 1);
		c.powerOnLED(0x03, 0);
		c.msDelay(500);
		c.powerOnLED(0x00, 1);
		c.powerOnLED(0x01, 0);
		c.powerOnLED(0x02, 0);
		c.powerOnLED(0x03, 1);
		c.msDelay(500);


	}
}

