#ifndef __BIOLOIDSERVO_H__
#define __BIOLOIDSERVO_H__

#include "global.h"
#include "BoardController.h"

#define BIOLOID_MAX_PARAM       8
#define BIOLOID_MAX_PACKETLEN    BIOLOID_MAX_PARAM+5
#define SERVO_X 0
#define SERVO_Y 1

#define lowbyte(w)  ((unsigned char) w)
#define highbyte(w) ((unsigned char) (w >> 8))


typedef struct
{
	unsigned char id;
	unsigned char paramLen;
	unsigned char instruction;
	unsigned char param[ BIOLOID_MAX_PARAM ];
} BioloidPacket;



class BioloidServo {

	public: 
		void setPosition(unsigned char _pos, unsigned char _scal);
		BioloidServo(unsigned char _id, unsigned int _minPos, unsigned int _maxPos);		
		static void TxPacket(BioloidPacket* bPacket, unsigned int milliDelay);
		static unsigned char RxPacket(BioloidPacket* bPacket);
		static bool RxByte(unsigned char* data);
		static bool pingServo(unsigned char _id);
		static void scanBioloidBus();
		//static void setBroadcastReturnDelayTime();

	

	private:
		unsigned int minPos, maxPos;
		unsigned char servoId;


		//unsigned char getServoId(unsigned char _id);

};


#endif
