#include "SensorOnlyMode.h"
#include "global.h"
#include <avr/interrupt.h>
#include <avr/signal.h>

volatile int wheel1 = 0;
volatile int wheel2 = 0; // not in use yet

extern Smartbuffer interruptbuff;
extern int softwareMode;


/** Interrupt-Service-Routine (ISR) for incremental encoder on INT0 */
SIGNAL(SIG_INTERRUPT0) {

	cli();

	register unsigned char pd = PIND;

	if (( (pd & (1<<PIND6))>=1  &&  (pd & (1<<PIND2))==0 ) ||
	    ( (pd & (1<<PIND6))==0  &&  (pd & (1<<PIND2))>=1 ) 
	) {
		if (softwareMode == SENSOR_MODE) {
			wheel1++;
		} else if (wheel1 < 127) { // only a char-byte will be saved in memory
			wheel1++;
		}

	} else {	
		if (softwareMode == SENSOR_MODE) {
			wheel1--;
		} else if (wheel1 > -127) { // only a char-byte will be saved in memory
			wheel1--;
		}	
	}

	sei();
}
// code from markus 
/*SIGNAL(SIG_INTERRUPT0)
{ 
  register unsigned char pd = PIND;
  register unsigned char pb = PINB;
  
  // if the signals are different is was
  // a forwad movement - else a backward movement
	if(
     ((pd & (1<<PIND2))>=1  &&  (pb & (1<<PINB0))==0) ||
     ((pd & (1<<PIND2))==0  &&  (pb & (1<<PINB0))>=1) 
     ){
    wheel1++;
	} 
  else{	
    wheel1--;
	}
}
SIGNAL(SIG_INTERRUPT1)
{ 
  register unsigned char pd = PIND;
  register unsigned char pb = PINB;
  
  // if the signals are different is was
  // a forwad movement - else a backward movement
	if(
     ((pd & (1<<PIND3))>=1  &&  (pb & (1<<PINB1))==0) ||
     ((pd & (1<<PIND3))==0  &&  (pb & (1<<PINB1))>=1) 
     ){
    wheel2++;
	} 
  else{	
    wheel2--;
	}
}
*/


/* Serial Interrupt Handler */
//ISR(USART_RXC_vect)
// SIGNAL(SIG_UART_RECV)
// {
// 	if (softwareMode == SENSOR_MODE) {
//   		push(interruptbuff, RXD_DATA);
// 	}
// }

