#ifndef __V24_COMMANDS_H__
#define __V24_COMMANDS_H__


// V24 Kommandos
#define V24_COMMAND_SYNC_COMMAND		0x00  // sync command (FROM GUI)
#define V24_COMMAND_SYNC_OK_COMMAND		0xff  // acknowledge synchronization (TO GUI)

#define V24_COMMAND_LED_ON 			0x01  // LED Test "on" (FROM GUI)
#define V24_COMMAND_LED_OFF 			0x02  // LED Test "off" (FROM GUI)

#define V24_COMMAND_GET_GAMMA			0x03  // set gamma to GUI (FROM GUI)
#define V24_COMMAND_SET_GAMMA			0x04  // set local gamma (FROM GUI, TO GUI)

#define V24_COMMAND_SET_GRIDSIZE		0x05  // set grid size (TO GUI)
#define V24_COMMAND_GET_GRIDSIZE		0x06  // send grid size to GUI (FROM GUI)

#define V24_COMMAND_START_WALKING		0x07  // walk current policy (FROM GUI)
#define V24_COMMAND_STOP_WALKING		0x08  // stop walking (FROM GUI)

#define V24_COMMAND_SET_STATE			0x09  // set a state (value+rewards) (FROM GUI, TO GUI)
#define V24_COMMAND_GET_STATE			0x0A  // send a state to the GUI (value+rewards) (FROM GUI)

#define V24_COMMAND_WRITE_RAM_BYTES		0x0B  // (Ramtest) write 16 bytes into the memory (FROM GUI, TO GUI)
#define V24_COMMAND_READ_RAM_BYTES		0x0C  // (Ramtest) send 16 bytes from the memory to the GUI (FROM GUI)

#define V24_COMMAND_EXPLORE_FEEDBACK		0x0D  // explore environment (FROM GUI)

#define V24_COMMAND_COMMAND_OK			0x0E  // signal that command arrived successfully (TO GUI)
#define V24_COMMAND_COMMAND_ERROR		0x0F  // signal that command that an error occured  (TO GUI)

#define V24_COMMAND_GET_CURRENT_STATE_MODE_ITERATIONS	0x10  // get current state, mode (FROM GUI)
#define V24_COMMAND_SET_CURRENT_STATE_MODE_ITERATIONS	0x11  // send current state, mode and iteration# to GUI and iteration# (TO GUI)

#define V24_COMMAND_SET_ALL_STATES_AND_GAMMA		0x12  // set all states (values+rewards) (FROM GUI, TO GUI)
#define V24_COMMAND_GET_ALL_STATES_AND_GAMMA		0x13  // get all states (values+rewards) (FROM GUI)

#define V24_COMMAND_GET_RAMSIZE				0x14  // get memory size (FROM GUI)
#define V24_COMMAND_SET_RAMSIZE				0x15  // send memory size (TO GUI)

#define V24_COMMAND_START_LEARNING			0x16  // robot should only perform value-iteration (FROM GUI)

#define V24_COMMAND_GET_DISTANCE			0x17  // get distance covered (FROM GUI)
#define V24_COMMAND_SET_DISTANCE			0x18  // set distance covered (TO GUI)
#define V24_COMMAND_RESET_DISTANCE_COUNTER		0x19  // reset distance counter (FROM GUI)

#define V24_COMMAND_SET_EXPLORATION_CONFIG		0x1A  // set exploration mode+parameter (FROM GUI, TO GUI)
#define V24_COMMAND_GET_EXPLORATION_CONFIG		0x1C  // get exploration mode+parameter (FROM GUI)

#define V24_COMMAND_WALK_AND_RETURN 			0x1B  // perform next action and return reward (FROM GUI)
#define V24_COMMAND_WALK_AND_RETURN_RESPONSE		0x1C  // returns reward + successor state (TO GUI)


#define V24_COMMAND_GET_DEBUG				0x1D // returns user defined debug information (FROM GUI)

#define V24_COMMAND_GET_CURRENT_STATE			0x1E // request for current robot state (FROM GUI)
#define V24_COMMAND_SET_CURRENT_STATE			0x1F // response for current robot state (TO GUI)


// V24 Servo Data
#define V24_DATA_SERVO_X		0x01
#define V24_DATA_SERVO_Y		0x02
#define V24_DATA_SERVO_Z		0x03

// Error-Codes
#define V24_ERRORCODE_UNKNOWN_COMMAND			0x01
#define V24_ERRORCODE_GRIDSIZE_TOO_LARGE		0x02
#define V24_ERRORCODE_SIZE_ERROR			0x03


#endif
